unit TestClsEstimate;
{

  Delphi NUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit
  being tested.

}

interface

uses
  NUnit.Framework, ClsEstimate;
type
  // Test methods for class TClsEstimate
  [TestFixture]
  TestTClsEstimate = class
  strict private
    FClsEstimate: TClsEstimate;
  public
    [SetUp]
    procedure SetUp;
    [TearDown]
    procedure TearDown;
  published
    [Test] procedure TestAddEstimateItem;
    [Test] procedure TestGetItem;
    [Test] procedure TestItemCount;
    [Test] procedure TestGetCost;
  end;

implementation

(* ******************************************* *)

procedure TestTClsEstimate.SetUp;
begin
  FClsEstimate := TClsEstimate.Create;
end;

procedure TestTClsEstimate.TearDown;
begin
  FClsEstimate := nil;
end;

(* ******************************************* *)

procedure TestTClsEstimate.TestAddEstimateItem;
begin
  FClsEstimate.ResetCount;
  FClsEstimate.AddEstimateItem('TEST', 100);

  Assert.IsTrue(FClsEstimate.ItemCount = 1);
end;

(* ******************************************* *)

procedure TestTClsEstimate.TestGetItem;
var ReturnValue: string;
begin
  FClsEstimate.ResetCount;

  FClsEstimate.AddEstimateItem('TEST', 200);

  ReturnValue := FClsEstimate.GetItem(1);

  Assert.AreEqual(ReturnValue, '200 TEST')
end;

(* ******************************************* *)

procedure TestTClsEstimate.TestItemCount;
var ReturnValue: Integer;
begin
  FClsEstimate.ResetCount;

  FClsEstimate.AddEstimateItem('TEST ITEM 1', 100);
  FClsEstimate.AddEstimateItem('TEST ITEM 2', 200);

  ReturnValue := FClsEstimate.ItemCount;

  Assert.AreEqual(ReturnValue, 2)
end;

(* ******************************************* *)

procedure TestTClsEstimate.TestGetCost;
var ReturnValue: double;
begin
  FClsEstimate.ResetCount;

  FClsEstimate.AddEstimateItem('TEST', 200);

  ReturnValue := FClsEstimate.GetCost(1);

  Assert.AreEqual(ReturnValue, 200);
end;

(* ******************************************* *)

end.

